module EvadosTracker
  class Core
    attr_accessor :numerated_list, :current_isssue_id, :pomodoro_id

    def initialize(key)
      @key = key
      @current_isssue_id
      @pomodoro_id
      @numerated_list = {}
    end

    def get_tasks
      begin
        response = HTTParty.get("http://pm.evados.com/api/v1/issues.json?auth_token=" + @key)
        numerate_task_list response
      rescue StandardError
        p "Have no internet connection"
      end
    end

    def create_pomodoro
      begin
        @pomodoro_id = HTTParty.post("http://pm.evados.com/api/v1/issues/" + "#{@current_isssue_id}" +
                      "/pomodoros.json?auth_token=" + @key)
      rescue StandardError
        p "Have no internet connection"
      end
    end

    def commit_pomodoro
      begin
        HTTParty.put("http://pm.evados.com/api/v1/issues/" + "#{@current_isssue_id}" +
                      "/pomodoros/" + "#{@pomodoro_id}" + ".json?auth_token=" + @key)
      rescue StandardError
        p "Have no internet connection"
      end
    end

    def delete_pomodoro
      begin
        HTTParty.delete("http://pm.evados.com/api/v1/issues/" + "#{@current_isssue_id}" +
                      "/pomodoros/" + "#{@pomodoro_id}" + ".json?auth_token=" + @key)
      rescue StandardError
        p "Have no internet connection"
      end
    end

    private

    def numerate_task_list(task_list)
      @numerated_list = {};
      task_list.each_with_index{ |t, index| @numerated_list["#{index + 1}"] = t }
    end
  end
end
